#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <vector>
using namespace std;

int n;
char word[128];
char words[128][32];
vector<int> posw[128];
char tmp[32];

void input() {
	scanf("%d%s", &n, word);
	int j, k;
	for(int i = 0; i < n; ++i) {
		scanf("%s", tmp);
		for(j = 0; tmp[j]; ++j)
			for(k = 0; word[k]; ++k)
				if(tmp[j] == word[k]) {
					posw[k].push_back(i);
				}
	}
	/*for(int i = 0; i < n; ++i) {
		printf("%d: ", i);
		for(int j = 0; j < posw[i].size(); ++j) {
			printf("%d ", posw[i][j]);
		}
		printf("\n");
	}*/
}

int cpos;
char freew[128], pos[128];
void init() {
	memset(freew, 1, sizeof(freew));
	cpos = 0;
}
long start;
int cnt;
void dfs() {
	if(cnt & 1<<9) {
		if(clock()-start >= CLK_TCK * 0.92) {
			printf("NO\n");
			exit(0);
		}
	}
	++cnt;
	
	if(cpos == n) {
		printf("YES\n");
		for(int i = 0; i < n; ++i) {
			printf("%d", pos[i]+1);
			if(i < n-1)
				printf(" ");
		}
		printf("\n");
		exit(0);
	}
	int cword;
	for(int i = 0, l = posw[cpos].size(); i < l; ++i) {
		cword = posw[cpos][i];
		if(freew[cword]) {
			freew[cword] = 0;
			pos[cpos] = cword;
			++cpos;
			
			dfs();
			
			--cpos;
			freew[cword] = 1;
		}
	}
}

int main() {
	start = clock();
	input();
	init();
	dfs();
	printf("NO\n");
	return 0;
}
