#include <iostream>
#include <string>
#include <queue>
#include <vector>
#include <cstdio>

using namespace std;

int A[256][256],n;
string name,cube;
int p[256],off[256],maxF,sink;
bool have=true,used[256];
queue<int> q;

void init()
{
 cin>>n;
 cin>>name;
 for(int i=1;i<=n;i++)
     {
      cin>>cube;
      for(int j=0;j<n;j++)
         {
          int pos=cube.find(name[j]);
          if(pos>=0 && pos<6) A[i][n+j+1]=1;
          } 
     }
 for(int i=1;i<=n;i++) {A[0][i]=1; A[n+i][2*n+1]=1;  }
 sink=2*n+1;
}


void bfs()
{
 memset(used,0,sizeof(used));
 p[0]=-1;
 used[0]=1;
 have=0;
 
 for(int i=0;i<=n;i++)
    if(A[0][i]) { q.push(i);  used[i]=1;}
 
 while(!q.empty())
 {
  int k=q.front(); q.pop();
  if(k==sink) { have=1; break;}
  for(int i=0;i<=sink;i++)
     if(A[k][i] && !used[i]) { used[i]=1; q.push(i); p[i]=k;}
 }   
 
 if(have) {maxF++;
          int g=sink;
          while(g!=0)
           { if(p[g]>=1 && p[g]<=n && g>n && g<=2*n) off[g]=p[g];
             A[p[g]][g]=0;
             A[g][p[g]]=1;
             g=p[g];
             }          
          }
}

void out()
{
 printf("YES\n");
 for(int i=n+1;i<sink;i++)
     printf("%d ",off[i]);
 printf("\n");
}

void maxFlow()
{
 while(have)  bfs(); 
 if(maxF!=n)  printf("NO\n");
 else out();
}

int main()
{init();
 maxFlow();

 return 0;
}
